#include <exec/exec.h>
#include <intuition/intuition.h>
#include <intuition/extensions.h>
#include <intuition/intuitionbase.h>
#include <devices/input.h>

#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/keymap.h>

#include "../client/client.h"

#include "in_morphos.h"

#define DEBUGRING(x)

#ifndef SA_Displayed
#define SA_Displayed (SA_Dummy + 101)
#endif

#define MAXIMSGS 32

#warning Fixme.
cvar_t *in_grabinconsole;

struct InputEvent imsgs[MAXIMSGS];
extern struct IntuitionBase *IntuitionBase;
extern struct Window *window;
extern struct Screen *screen;
extern void *pointermem;
static int imsglow = 0;
static int imsghigh = 0;

static qboolean mouse_active = qtrue;

static struct Interrupt InputHandler;

static struct Interrupt InputHandler;
static struct MsgPort *inputport = 0;
static struct IOStdReq *inputreq = 0;
static BYTE inputret = -1;

struct InputEvent *myinputhandler_real(void);

static int mousex[3], mousey[3];
static unsigned int mousebuf;

struct EmulLibEntry myinputhandler =
{
	TRAP_LIB, 0, (void(*)(void))myinputhandler_real
};

unsigned char keyconv[] =
{
	'`', /* 0 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 10 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 20 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 30 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 40 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 50 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 60 */
	0,
	0,
	0,
	0,
	K_BACKSPACE,
	K_TAB,
	KP_ENTER,
	K_ENTER,
	K_ESCAPE,
	K_DEL, /* 70 */
	K_INS,
	K_PGUP,
	K_PGDN,
	0,
	K_F11,
	K_UPARROW,
	K_DOWNARROW,
	K_RIGHTARROW,
	K_LEFTARROW,
	K_F1, /* 80 */
	K_F2,
	K_F3,
	K_F4,
	K_F5,
	K_F6,
	K_F7,
	K_F8,
	K_F9,
	K_F10,
	0, /* 90 */
	0,
	0,
	0,
	0,
	0,
	K_SHIFT,
	K_SHIFT,
	0,
	K_CTRL,
	K_ALT, /* 100 */
	K_ALT,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	K_PAUSE, /* 110 */
	K_F12,
	K_HOME,
	K_END,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 120 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 130 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 140 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 150 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 160 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 170 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 180 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 190 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 200 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 210 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 220 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 230 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 240 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0, /* 250 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0
};

void IN_Shutdown(void)
{
	if (inputret == 0)
	{
		inputreq->io_Data = (void *)&InputHandler;
		inputreq->io_Command = IND_REMHANDLER;
		DoIO((struct IORequest *)inputreq);

		CloseDevice((struct IORequest *)inputreq);

		inputret = -1;
	}

	if (inputreq)
	{
		DeleteIORequest(inputreq);

		inputreq = 0;
	}

	if (inputport)
	{
		DeleteMsgPort(inputport);

		inputport = 0;
	}
}

void IN_Init()
{
	if (inputport)
		return;

	inputport = CreateMsgPort();
	if (inputport == 0)
	{
		IN_Shutdown();
		Sys_Error("Unable to create message port\n");
	}

	inputreq = CreateIORequest(inputport, sizeof(*inputreq));
	if (inputreq == 0)
	{
		IN_Shutdown();
		Sys_Error("Unable to create IO request\n");
	}

	inputret = OpenDevice("input.device", 0, (struct IORequest *)inputreq, 0);
	if (inputret != 0)
	{
		IN_Shutdown();
		Sys_Error("Unable to open input.device");
	}

	mousebuf = 0;
	mousex[0] = mousex[1] = mousex[2] = 0;
	mousey[0] = mousey[1] = mousey[2] = 0;

	InputHandler.is_Node.ln_Type = NT_INTERRUPT;
	InputHandler.is_Node.ln_Pri = 100;
	InputHandler.is_Node.ln_Name = "Fuhquake input handler";
	InputHandler.is_Data = 0;
	InputHandler.is_Code = (void(*)())&myinputhandler;
	inputreq->io_Data = (void *)&InputHandler;
	inputreq->io_Command = IND_ADDHANDLER;
	DoIO((struct IORequest *)inputreq);

	in_grabinconsole = Cvar_Get ("in_grabinconsole", "0", CVAR_ARCHIVE);
}

void IN_Restart(void)
{
	IN_Shutdown();
	IN_Init();
}

static void ExpireRingBuffer()
{
	int i = 0;

	while(imsgs[imsglow].ie_Class == IECLASS_NULL && imsglow != imsghigh)
	{
		imsglow++;
		i++;
		imsglow%= MAXIMSGS;
	}

	DEBUGRING(dprintf("Expired %d messages\n", i));
}

void IN_Frame()
{
	char key;
	int i;
	int down;
	unsigned int time = Sys_Milliseconds();

	struct InputEvent ie;

	for(i = imsglow;i != imsghigh;i++, i%= MAXIMSGS)
	{
		DEBUGRING(dprintf("%d %d\n", i, imsghigh));
		if ((window->Flags & WFLG_WINDOWACTIVE))
		{
			if (imsgs[i].ie_Class == IECLASS_NEWMOUSE)
			{
				key = 0;

				if (imsgs[i].ie_Code == NM_WHEEL_UP)
					key = K_MWHEELUP;
				else if (imsgs[i].ie_Code == NM_WHEEL_DOWN)
					key = K_MWHEELDOWN;

				if (imsgs[i].ie_Code == NM_BUTTON_FOURTH)
				{
					Key_Event(K_MOUSE4, qtrue, time);
				}
				else if (imsgs[i].ie_Code == (NM_BUTTON_FOURTH|IECODE_UP_PREFIX))
				{
					Key_Event(K_MOUSE4, qfalse, time);
				}

				if (key)
				{
					Key_Event(key, 1, time);
					Key_Event(key, 0, time);
				}

			}
			else if (imsgs[i].ie_Class == IECLASS_RAWKEY)
			{
				bzero(&ie, sizeof(ie));

				ie.ie_Class = IECLASS_RAWKEY;
				ie.ie_SubClass = 0;
				ie.ie_Code = imsgs[i].ie_Code&~(IECODE_UP_PREFIX);
				ie.ie_Qualifier = imsgs[i].ie_Qualifier&~(IEQUALIFIER_CONTROL);

				if (MapRawKey(&ie, &key, 1, 0) > 0)
				{
					if ((imsgs[i].ie_Code&IECODE_UP_PREFIX) == 0)
						Key_CharEvent(key);
				}
				else
					key = 0;

				down = !(imsgs[i].ie_Code&IECODE_UP_PREFIX);
				imsgs[i].ie_Code&=~IECODE_UP_PREFIX;

				if (imsgs[i].ie_Code <= 255 && keyconv[imsgs[i].ie_Code] != 0)
					key = keyconv[imsgs[i].ie_Code];

				if (key)
				{
					Key_Event(key, down, time);
				}
				else
				{
					if (developer->value)
						Com_Printf("Unknown key %d\n", imsgs[i].ie_Code);
				}
			}
			else if (imsgs[i].ie_Class == IECLASS_RAWMOUSE)
			{
				if (imsgs[i].ie_Code == IECODE_LBUTTON)
					Key_Event(K_MOUSE1, qtrue, time);
				else if (imsgs[i].ie_Code == (IECODE_LBUTTON|IECODE_UP_PREFIX))
					Key_Event(K_MOUSE1, qfalse, time);
				else if (imsgs[i].ie_Code == IECODE_RBUTTON)
					Key_Event(K_MOUSE2, qtrue, time);
				else if (imsgs[i].ie_Code == (IECODE_RBUTTON|IECODE_UP_PREFIX))
					Key_Event(K_MOUSE2, qfalse, time);
				else if (imsgs[i].ie_Code == IECODE_MBUTTON)
					Key_Event(K_MOUSE3, qtrue, time);
				else if (imsgs[i].ie_Code == (IECODE_MBUTTON|IECODE_UP_PREFIX))
					Key_Event(K_MOUSE3, qfalse, time);
			}
		}

		imsgs[i].ie_Class = IECLASS_NULL;
	}

	ExpireRingBuffer();
}

void IN_Commands(void)
{
}

void IN_Move(usercmd_t *cmd)
{
	double mx, my;
	unsigned int mbuf;

	mbuf = mousebuf;
	mousebuf = (mousebuf+1)%3;

	mx = mousex[mbuf];
	my = mousey[mbuf];

	mousex[mbuf] = 0;
	mousey[mbuf] = 0;

	CL_MouseMove(cmd, mx, my);
}

#warning fixme
void IN_Activate(qboolean active)
{
	mouse_active = active;

	if (active)
	{
		SetPointer(window, pointermem, 16, 16, 0, 0);
	}
	else
		ClearPointer(window);
}

struct InputEvent *myinputhandler_real()
{
	struct InputEvent *moo = (struct InputEvent *)REG_A0;

	struct InputEvent *coin;

	ULONG screeninfront;

	if (!(window->Flags & WFLG_WINDOWACTIVE))
		return moo;

	coin = moo;

	if (screen)
	{
		if (IntuitionBase->LibNode.lib_Version > 50 || (IntuitionBase->LibNode.lib_Version == 50 && IntuitionBase->LibNode.lib_Revision >= 56))
			GetAttr(SA_Displayed, screen, &screeninfront);
		else
			screeninfront = screen == IntuitionBase->FirstScreen;
	}
	else
		screeninfront = 1;

	do
	{
		if (coin->ie_Class == IECLASS_RAWMOUSE)
		{
			mousex[mousebuf] += coin->ie_position.ie_xy.ie_x;
			mousey[mousebuf] += coin->ie_position.ie_xy.ie_y;
		}
		if ((coin->ie_Class == IECLASS_RAWMOUSE && coin->ie_Code != IECODE_NOBUTTON) || coin->ie_Class == IECLASS_RAWKEY || coin->ie_Class == IECLASS_NEWMOUSE)
		{
			if ((imsghigh > imsglow && !(imsghigh == MAXIMSGS - 1 && imsglow == 0)) || (imsghigh < imsglow && imsghigh != imsglow - 1) || imsglow == imsghigh)
			{
				memcpy(&imsgs[imsghigh], coin, sizeof(imsgs[0]));
				imsghigh++;
				imsghigh %= MAXIMSGS;
			}
			else
			{
				DEBUGRING(kprintf("FodQuake: message dropped, imsglow = %d, imsghigh = %d\n", imsglow, imsghigh));
			}
		}

		if (mouse_active && (window->Flags & WFLG_WINDOWACTIVE) && coin->ie_Class == IECLASS_RAWMOUSE && screeninfront && window->MouseX > 0 && window->MouseY > 0)
		{
			coin->ie_position.ie_xy.ie_x = 0;
			coin->ie_position.ie_xy.ie_y = 0;
		}
	
		coin = coin->ie_NextEvent;
	} while (coin);

	return moo;
}

