#include "../client/client.h"

viddef_t viddef;

cvar_t *vid_fullscreen;
qboolean vid_ref_modified;
qboolean vid_ref_active;

void VID_Restart()
{
	vid_ref_modified = qtrue;
}

void VID_Restart_f()
{
	VID_Restart();
}

void VID_CheckChanges()
{
	if (vid_ref_modified)
	{
		qboolean cgameactive = cls.cgameActive;

		cls.disable_screen = qtrue;

		IN_Shutdown();
		CL_ShutdownMedia();

		if (vid_ref_active)
		{
			R_Shutdown();
			vid_ref_active = 0;
		}

		if (R_Init(0, 0) == -1)
			Com_Error(ERR_FATAL, "Failed to open display");

		CL_InitMedia();
		IN_Init();

		cls.disable_screen = qfalse;

		Con_Close();

		Key_ClearStates();
		if (cgameactive)
		{
			CL_GameModule_Init();
			CL_SetKeyDest(key_game);
		}
		else
		{
			Cbuf_ExecuteText(EXEC_NOW, "menu_main");
			CL_SetKeyDest(key_menu);
		}

		vid_ref_active = qtrue;
		vid_ref_modified = qfalse;
	}
}

void VID_NewWindow(int width, int height)
{
	viddef.width = width;
	viddef.height = height;
}

void VID_Init()
{
	vid_fullscreen = Cvar_Get("vid_fullscreen", "0", CVAR_ARCHIVE);

	Cmd_AddCommand ("vid_restart", VID_Restart_f);

	vid_ref_modified = qtrue;
	vid_ref_active = qfalse;
	vid_fullscreen->modified = qtrue;
	VID_CheckChanges();
}

void VID_Shutdown()
{
	if (vid_ref_active)
	{
		R_Shutdown();
		vid_ref_active = qfalse;
	}

	Cmd_RemoveCommand("vid_restart");
}

